
DROP PROCEDURE GETNEXTSEQID;
GO

CREATE PROCEDURE GETNEXTSEQID
@pServer_ID ARADMIN_TXID_SERVER_ID_TYPE,
@pInstance_ID ARADMIN_TXID_INSTANCE_ID_TYPE,
@pIP_Address ARADMIN_TXID_IP_ADDRESS_TYPE,
@pBlock_Size INT,
@pReturn_Seq_ID ARADMIN_TXID_USED_SEQ_NUM_TYPE OUTPUT
AS 
DECLARE @lnewseq INT;
DECLARE @errorvar INT SET @errorvar = -1 ;

SET NOCOUNT ON;
SELECT @errorvar = USEDSEQNUM FROM ARADMINTXID
WHERE SERVERID = @pServer_ID AND INSTANCEID = @pInstance_ID;

IF @errorvar = -1
BEGIN
SET @pReturn_Seq_ID = 0
INSERT INTO ARADMINTXID
(SERVERID, INSTANCEID, IPADDRESS, USEDSEQNUM)
VALUES (@pServer_ID, @pInstance_ID, @pIP_Address, @pBlock_Size);

RETURN
END
ELSE
BEGIN
SET @pReturn_Seq_ID = @errorvar;
SET @lnewseq = @pReturn_Seq_ID + @pBlock_Size;

UPDATE ARADMINTXID SET USEDSEQNUM = @lnewseq, IPADDRESS = @pIP_Address
WHERE SERVERID = @pServer_ID AND INSTANCEID = @pInstance_ID;
END
RETURN

